/// <reference types="react" />
import { IApp, IPlatformApp } from '@cloudbase/cals';
import { IAppProps } from './index';
import { IComponentInfo } from '../utils/adapter/generate';
export declare type TCALS = IApp | IPlatformApp;
interface IPackageProps extends Pick<IAppProps, 'generateComponentsMap' | 'generateActionsMap' | 'onRender' | 'initDataContext' | 'renderLoading'> {
    cals: TCALS;
    componentsInfoMap: Record<string, IComponentInfo>;
    lowcodeModuleMap: {
        [pageId: string]: any;
    };
    historyOption?: {
        _indexPage?: boolean;
    };
    onPageMounted?: IAppProps['onMounted'];
    pageOptions?: IAppProps['options'];
    onNotFound?: Function;
}
export declare function PackageRender({ cals, componentsInfoMap, lowcodeModuleMap, historyOption, generateComponentsMap, generateActionsMap, onPageMounted, pageOptions, onRender, initDataContext, renderLoading, onNotFound, }: IPackageProps): JSX.Element;
export {};
