"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PackageRender = void 0;
const tslib_1 = require("tslib");
const React = tslib_1.__importStar(require("react"));
const react_router_dom_1 = require("react-router-dom");
const index_1 = tslib_1.__importDefault(require("./index"));
const generate_1 = require("../utils/adapter/generate");
const status_1 = require("./status");
const common_1 = require("../utils/common");
function PackageRender({ cals, componentsInfoMap, lowcodeModuleMap, historyOption, generateComponentsMap, generateActionsMap, onPageMounted, pageOptions, onRender, initDataContext, renderLoading, onNotFound, }) {
    const { items } = cals;
    const home = React.useMemo(() => {
        return (items || []).find((item) => item.id === cals.main);
    }, [items, cals.main]);
    return (React.createElement(react_router_dom_1.Routes, null,
        home && (React.createElement(react_router_dom_1.Route, { path: "/", element: React.createElement(react_router_dom_1.Navigate, { to: `.${(0, common_1.generatePageRelativePath)(home, historyOption === null || historyOption === void 0 ? void 0 : historyOption._indexPage)}`, replace: true }) })),
        items.map((page) => {
            const uuid = cals.extra.rootPath ? `${cals.extra.rootPath}/${page.id}` : page.id;
            return (React.createElement(react_router_dom_1.Route, { key: page.id, path: (0, common_1.generatePageRelativePath)(page, historyOption === null || historyOption === void 0 ? void 0 : historyOption._indexPage), element: React.createElement(index_1.default, { page: Object.assign(Object.assign({}, page), { uuid }), generateComponentsMap: generateComponentsMap, generateActionsMap: generateActionsMap, generateLowcodeModule: () => {
                        console.log('lowcodeModuleMap', lowcodeModuleMap);
                        return lowcodeModuleMap[uuid] || {};
                    }, generateContext: (ctx, page, options) => {
                        const { widgets, componentSchema, dataBinds } = (0, generate_1.getComponentSchema)(ctx, page, componentsInfoMap, undefined, {
                            isComposite: false,
                            looseError: options.looseError,
                            processCssUnit: options.processCssUnit,
                        });
                        return {
                            widgetContext: widgets,
                            componentSchema,
                            dataBinds,
                        };
                    }, onMounted: onPageMounted, onRender: onRender, initDataContext: initDataContext, options: pageOptions, renderLoading: renderLoading }) }));
        }),
        React.createElement(react_router_dom_1.Route, { path: "/1", element: React.createElement(MockPage, null) }),
        React.createElement(react_router_dom_1.Route, { path: "*", element: React.createElement(status_1.NotFound, { onNotFound: onNotFound }) })));
}
exports.PackageRender = PackageRender;
function MockPage() {
    const location = (0, react_router_dom_1.useLocation)();
    return (React.createElement(React.Fragment, null,
        React.createElement("p", null, "subpackage path"),
        React.createElement("p", null, location.pathname)));
}
//# sourceMappingURL=package.js.map